1.85 Approximation for Min-Power Strong Connectivity
Abstract
Given a directed simple graph and a cost function , the power of a vertex in a directed spanning subgraph is given by , and corresponds to the energy consumption required for wireless node to transmit to all nodes with . The power of is given by .
Power Assignment seeks to minimize while satisfies some connectivity constraint. In this paper, we assume is bidirected (for every directed edge , the opposite edge exists and has the same cost), while is required to be strongly connected. This is the original power assignment problem introduced by Chen and Huang in 1989, who proved that a bidirected minimum spanning tree has approximation ratio at most 2 (this is tight). In Approx 2010, we introduced a Greedy approximation algorithm and claimed a ratio of . Here we improve the analysis to , combining techniques from Robins-Zelikovsky (2000) for Steiner Tree, and Caragiannis, Flammini, and Moscardelli (2007) for the broadcast version of Power Assignment, together with a simple idea inspired by Byrka, Grandoni, Rothvoร, and Sanitร (2010).
The proof also shows that a natural linear programming relaxation, introduced by us in 2012, has the same integrality gap.
1 Introduction
There has been a surge of research in Power Assignment problems since 2000 (among the earlier papers are [18, 22, 13]) This class of problems take as input a directed simple graph and a cost function . The power of a vertex in a directed spanning simple subgraph of is given by , and corresponds to the energy consumption required for wireless node to transmit to all nodes with . The power (or total power) of is given by .
The study of the min-power power assignment was started by Chen and Huang [8], which consider, as we do, the case when is bidirected, (that is, if and only if , and if weighted, the two edge have the same cost; this case was sometimes called โsymmetricโ or โundirectedโ in the literature) while is required to be strongly connected. We call this problem Min-Power Strong Connectivity. We use with the same name both the (bi)directed and the undirected version of . [8] prove that the bidirected version of a minimum (cost) spanning tree (MST) of the input graph has power at most twice the optimum, and therefore the MST algorithm has approximation ratio at most 2. This is known to be tight (see Section 2).
We improve this to by combining techniques from Robins-Zelikovsky [19, 20] for Steiner Tree, Caragiannis, Flammini, and Moscardelli [6] for the broadcast version of symmetric Power Assignment (assuming a bidirected and a โrootโ is given, must contain a directed path from to every vertex of ), together with a simple idea inspired by Byrka, Grandoni, Rothvoร, and Sanitร (2010).
Very restricted versions of Min-Power Strong Connectivity have been proven NP-Hard [15, 10, 7]. Other than [4], we are not aware of better than a factor of 2 approximation except for [7], (where , for ; see also [4]), [2] (where is assumed to be a metric), and the exact (dynamic programming) algorithms of [15] for the specific case where each vertex of maps to a point on a line, and is an increasing function of the Euclidean distance between the images of and . A related version, also NP-Hard, asks for to be bidirected (also called โundirectedโ or โsymmetricโ in previous papers). This problem is called Min-Power Symmetric Connectivity, and the best known ratio of [1] is obtained with techniques first applied to Steiner Tree; when one gets with the same method [17]. In fact, many but not all power assignment algorithms use techniques from Steiner Tree variants (or direct reduction to Steiner Tree variants; these connections to Steiner Tree are not obvious and cannot be easily explained), and in particular Caragiannis et al [6] uses the relative greedy heuristic of Zelikovsky [23]. New interesting techniques were also developed for power assignment problems, as in [16], an improvement over [14].
The existing lower bound of the optimum, which we use, is the cost of the minimum spanning tree of . Indeed (argument from [8]), the optimum solution contains an in-arborescence rooted at , for some , and then, for all , is at least the cost of the directed edge connecting to its parent in this in-arborescence, whose total cost is at least the cost of the minimum spanning tree of .
We also use a relative greedy method as in [23, 19]; Robins-Zelikovsky [19] is rarely used as a technique, and not by only citing the ratio (improved by now in [3]). We use the natural structures of [6] to improve over the minimum spanning tree: these are stars, directed trees of height 1. Our second lower bound (improved over [4]) comes from โcoveringโ the edges of the a spanning tree by the stars of the optimum solution. With precise definitions later, we just mention that an edge of a tree is covered by a star if it is on a path of the tree between two vertices of the star. A โcheapโ fractional covering can be easily obtained from either optimum or the linear programming relaxation. In our earlier work [4], we used an integer cover which was extremely hard to obtain. Using fractional covers (inspired by [3]) is the only significant difference of this version versus [4]. Also, interestingly, the submodularity of the covering function is only used implictly.
2 Preliminaries
In directed graphs, we use arc to denote a directed edge. In a directed graph , an incoming arborescence rooted at is a spanning subgraph of such that the underlying undirected graph of is a tree and every vertex of other than has exactly one outgoing arc in .
Given an arc , its undirected version is the undirected edge with endpoints and . Arcs and are antiparallel, and the antiparallel arcs resulting from undirected edge are and ; if undirected edge has cost, then each of the two antiparallel arcs resulting from undirected edge have this cost. We sometimes identify a spanning tree with its set of edges.
An alternative definition of our problem (how it was originally posed) is: we are given a simple undirected graph and a cost function . A power assignment is a function , and it induces a simple directed graph on vertex set given by being an arc of if and only if and . The problem is to minimize subject to being strongly connected. To see the equivalence of the definition, given directed spanning subgraph , define for each the power assignment .
The following known example (see Figure 1) shows that the ratio of 2 for the MST algorithm is tight. Consider points located on a single line such that the distance between consecutive points alternates between 1 and , and let the cost function be the square of the Euclidean distance Then the minimum spanning tree MST connects consecutive neighbors and has power . On the other hand, the bidirected tree with arcs connecting each other node (see Figure 1(b)) has power equal . When and , we obtain that . On the other hand (argument taken from [8]), for any input graph, the power of the bidirected minimum spanning tree is at most
where for an optimum solution (the last inequality is from the introduction).
The example above may give intuition on how Power Assignment (and even more specifically, Min-Power Symmetric Connectivity - the variant when must be bidirected mentioned in the introduction) relates to the -restricted Steiner trees, with stars (trees of height 1) taking the place of restricted components. Another example from [1], (see Figure 2, and the following paragraph), shows how Min-Power Strong Connectivity differs from Min-Power Symmetric Connectivity, and may give intuition how Min-Power Strong Connectivity relates to Travelling Salesman, and also Min-Cost Strong Connectivity and Min-Cost Two-Edge Connectivity (a two-edge-connected graph has an edge orientation that makes it strongly connected - see for example Chapter 2, written by A. Frank, of [11]). However we cannot think of direct reductions either way, and, as we mention in Conclusions, the methods we use only apply to certain instances of Min-Cost Strong Connectivity and Min-Cost Two-Edge Connectivity.
The power of a Min-Power Strong Connectivity optimum solution can be almost half the power of a Min-Power Symmetric Connectivity optimum solution for the same instance: we present a series of examples illustrated in Figure 2. The vertices are embedded in the plane in groups of points each. Each group has two โterminalsโ (represented as thick circles in Figure 2), and the terminals are the corners of a regular -gon with sides of length 1. Each group has another equally spaced points (dashes in Figure 2) on the line segment between the two terminals. The cost function is the square of the Euclidean distance. It is easy to see that a minimum power assignment ensuring strong connectivity assigns a power of 1 to one thick terminal in each group and a power of to all other points in the group - the arcs going clockwise. The total power then equals . For symmetric connectivity it is necessary to assign power of 1 to all but two of the thick points, and of to the remaining points, which results in total power . Also, keep in mind that the minimum spanning tree solution is a symmetric solution.
3 The Approximation Algorithm
This section is dedicated to proving the main result of this paper:
Theorem 1
There exists a polynomial time algorithm for Min-Power Strong Connectivity with approximation ratio .
The outline of the proof of Theorem 1, is as follows:
-
1.
In the first subsection, we present the greedy algorithm, preceded by necessary notation.
-
2.
Then we establish (Lemma 3) that the algorithmโs output is strongly connected.
-
3.
A second subsection gives the analysis. It starts with the new lower bound, the fractional cover of tree edges by stars.
- 4.
3.1 The algorithm
Our algorithm uses a greedy approach similar to [23, 19, 6]. Let be the undirected minimum spanning tree of . The fact that has minimum cost will be not further used, except to note , where for an optimum solution . Let be the bidirected version of .
For and , let be the directed star with center containing all the arcs with ; note that is the power of , also denoted by . For a directed star , let be its set of arcs and be its set of vertices.
For given , let be the set of edges of such that there exist with on the path from to in . Let be the set of arcs of such that there exist with on the directed path from to in ; it is easy to verify that the undirected version of is .
For a collection of directed stars , define and . We sometimes write instead of . The function is known to be monotone and submodular (see an example in [21], pages 768-769). For , recall that , where is defined to be those arcs of for which the undirected version is not in .
The algorithm starts with as the set of arcs, and adds directed stars to collection (initially empty) replacing arcs from to greedily reduce the sum of costs of the arcs in plus the sum of the powers of the stars in . For intuition, we mention that this sum is our upper bound on the power of the algorithmโs output. To simplify later proofs, the algorithm makes changes (adding directed stars and removing arcs from ) even if our sum stays the same. Assume below that . To be precise:
Algorithm Greedy: | |||
, | |||
While ( ) do | |||
Output |
Each of figures 3 and 4 shows two iterations of the algorithm. For intuition, we mention that this algorithm โcoversโ undirected edges of the minimum spanning tree by โstarsโ and when implemented, it is a variant of Chvatalโs [9] greedy algorithm for Set Cover.
Fact 2
Note that, unless , a star always exists for which and . Indeed, as long as a pair of antiparallel arcs and are in , we can pick as next star the one given by being the tail of and .
Thus, as written, the algorithm can have iterations that do not change the output, i.e. above the star above could have just the edge and be added to while is removed from .
Lemma 3
The output of Greedy is a spanning strongly connected subgraph of .
Proof. ย We prove the following invariant: gives a spanning strongly connected subgraph whenever the while condition is checked by the algorithm. Moreover, suppose we remove from all edges for which both antiparallel arcs appear in , splitting in components with vertex sets , for some range of . We prove that for every and every , there exists a directed path from to using only vertices of and arcs from .
Proving the invariant holds is done as always by induction on the number of iterations. The invariant is true before the first iteration, when each has just one vertex, so consider the moment when a star is added to . Figure 5 may provide intuition. We add arcs , for , while removing from (and from ) arcs if and there is some such that is on the directed simple path from to in . The same effect is obtained if we do this change for each one after the other, instead of all such at the same time.
Let be the simple path in from to , and let , for , be, in order, the arcs of on such that also . Thus the change to consists of adding the arc and removing all arcs ; note that if no arc is removed and our induction step is complete. Let and . We need to show that and satisfy the conditions from the induction hypothesis.
Let us split into components by removing all the undirected edges with both antiparallel arcs and in ; in particular all , for , resulting in components .
By induction, contains the following directed paths: from to , from to , โฆ, from to , and from to , and each of these paths stays in the same component of the split of by - as in the previous paragraph. Thus none of these paths uses or . Putting together these paths, the arcs , for , and the arc , we have a directed cycle containing none of the arcs , for . Any arc removed can be replaced, when discussing connectivity, with a path around the cycle , and so is strongly connected, as required.
We now split into components by removing all the undirected edges with both and in , obtaining components . Note that none of , , from above, has an arc with endpoints in two distinct components (as is the union of several ). As all the edges on the path from to in do not have anymore both antiparallel arcs in , all the vertices on this path including and all are in the same component of the split of by . Thus all the arcs of have their endpoints in the same component of the split of by .
We prove that for every and every , there exists a directed path from to using only vertices of and arcs from . First, let us describe a path from to using only arcs of : find the path from to in , and let , for , be, in order, the arcs of on such that also . When , for some (same component of the split of by ) and by induction, a path from to exists in using only vertices inside . We pick , and indeed only uses arcs of since the arcs of (same set as ) cross from one component to another of the split of by . Assume now . Notice that all unordered pairs belong in the set of unordered pairs on the simple path from to mentioned earlier, or else we cannot have that and belong to the same of the split of by . Also, by induction, contains the following directed paths: from to , from to , โฆ, from to , and from to , and each of these paths stays in the same component of the split of by . Thus none of these paths uses or . Next, obtain by replacing in , if necessary, arcs of (same set as ) by arcs of , staying, as shown in the previous paragraph, in the same component of split by . Note that indeed uses only vertices of . This completes the induction step. ย ย
3.2 Approximation ratio analysis
For a collection of directed stars , define , the total power used by the stars in .
Lemma 4
Let be a an arbitrary collection of stars, and be an arbitrary spanning tree. There exist non-negative coefficients (over the collection of all possible stars ) such that and .
Proof. ย We assume that , or else for all will do. Assign for every star of , and otherwise. Therefore .
Recall that and let . If we remove from , we create two subtrees and , where and are the endpoints of . , being strongly connected, has at least one star with the center in and one of its other vertices in . Then . Similarly, has at least one star with the center in and one of its other vertices in . Then . Note that (centers in disjoint vertex sets).
We have:
where the inequation is given by the two distinct stars and described above for every edge . This completes the proof. ย ย
The example from Figure 1 shows that a constant better than is not possible above: with being empty, we have circa , and for each star of optimum, is circa and circa .
Now we need the following lemma, whose proof is obtained from Robins-Zelikovsky as presented in [12] by changing what quantities represent and some parameters, together with a โfractional coverโ idea from the journal submission version of [3].
Lemma 5
Assuming that for the minimum spanning tree , and for any collection of stars , there exist non-negative coefficients such that and , where is the power of the optimum solution and , the algorithmsโ output has power at most where .
Proof. ย First, if , then before any improvement we have a solution of cost at most and . Thus in the following we assume (the first inequality is due to being a minimum spanning tree).
Note that at the end of the algorithm, contains exactly one of the two antiparallel arcs for each edge of . Then, for the final collection of stars , the output satisfies
(1) |
as it follows by summation over from
which holds for every vertex (recall that ).
Let be the stars picked by our algorithm and let , for be the collection of the first stars; also let for convenience be the empty collection. For , let , and let . Note then that for all , since , we have .
If , then and Equation 2 below holds. Otherwise, the greedy choice of the algorithm and the assumptions of the theorem for give:
Therefore (see Figure 6):
Using this and and Equation 1 (recall that ), we obtain that the power of the output is at most
finishing the proof. ย ย
4 Linear Programming Relaxation
While not improving the approximation ratio of Greedy, this may allow for further LP-based algorithm. The following natural Integer Linear Program is called IP2 as in [5]. We adapted the notation, and have variables for every arc . The idea is that being 1 โrepresentsโ that is star of the optimum solution. We say that star , for iff and .
(3) | |||||
(4) | |||||
(5) |
LP2 is the linear relaxation of IP2; that is, the linear program given by exactly the same constraints except the last one. LP2 has exponentially many โcutโ constraints, but when we replace them by โflowsโ, we have non-zero entries in the matrix, as shown in [5]. Thus it can be solved in polynomial-time.
Let be the optimum of the linear program LP2 for a given instance. Then clearly and [5] proves that . We do better here. First, Lemma 4 has a straightforward adaptation:
Lemma 6
Let be a an arbitrary collection of stars, and be an arbitrary spanning tree. There exist non-negative coefficients (over the collection of all possible stars ) such that and .
Proof. ย We assume that , or else for all will do. Let (for all ) be a an optimum solution of LP2. Assign for all ; therefore .
Recall that and let . If we remove from , we create two subtrees and , where and are the endpoints of . Constraint 3 gives
and
Note that and are disjoint sets since a star in the first set has its center in , while a star in the second set has its center in . Moreover, any star has . Thus
(6) |
From now on we coppied from the previous proof:
where the inequation is from (6). This completes the proof. ย ย
The example from Figure 1 again shows that a constant smaller than is not possible in Lemma 6: with being empty, we that for each star with , . Thus, if , then , where we used that the example can be made to have , for any . As and can be made arbitraly small, we can see that indeed a constant smaller than is not possible.
5 Conclusions
This work greatly simplifies and at the same time improves our earlier work [4]. Instead of Greedy we could have used the the iterative randomized rounding of Byrka et. al [3] for Steiner Tree, with the same approximation ratio. However, we do not see further improvements coming from using their full range of techniques, since we do not see the equivalent of the concept of โlossโ used explicitly by [19] and implicitly by [3].
6 Acknowledgments
We would like to thank Alexander Zelikovsky for a streamlined explanation of his algorithms, and to Gianpiero Monaco and Anna Zych for a group reading of [3] at the University of Warsaw.
References
- [1] E.ย Althaus, G.ย Calinescu, I.ย Mandoiu, S.ย Prasad, N.Tchervenski, and A.ย Zelikovsky. Power efficient range assignment for symmetric connectivity in static ad hoc wireless networks. Wireless Networks, 12(3):287โ299, 2006.
- [2] Christoph Ambรผhl, Andrea E.ย F. Clementi, Paolo Penna, Gianluca Rossi, and Riccardo Silvestri. On the approximability of the range assignment problem on radio networks in presence of selfish agents. Theor. Comput. Sci., 343(1-2):27โ41, 2005.
- [3] Jaroslaw Byrka, Fabrizio Grandoni, Thomas Rothvoร, and Laura Sanitร . An improved LP-based approximation for Steiner tree. In STOC โ10: Proceedings of the 42nd ACM symposium on Theory of computing, pages 583โ592, New York, NY, USA, 2010. ACM.
- [4] G.ย Calinescu. Min-power strong connectivity. In M.ย Serna, K.ย Jansen, and J.ย Rolin, editors, Proceedings of the International Workshop on Approximation Algorithms for Combinatorial Optimization, number 6302 in Lecture Notes in Computer Science, pages 67โ80. Springer, 2010.
- [5] G.ย Calinescu and K.ย Qiao. Asymetric topology control: exact solutions and fast approximations. In Infocom, 2012.
- [6] Ioannis Caragiannis, Michele Flammini, and Luca Moscardelli. An Exponential Improvement on the MST Heuristic for Minimum Energy Broadcasting in Ad Hoc Wireless Networks. In ICALP, pages 447โ458, 2007.
- [7] Paz Carmi and Matthewย J. Katz. Power assignment in radio networks with two power levels. Algorithmica, 47(2):183โ201, 2007.
- [8] W.T. Chen and N.F. Huang. The strongly connecting problem on multihop packet radio networks. IEEE Transactions on Communications, 37(3):293โ295, 1989.
- [9] V.ย Chvรกtal. A greedy heuristic for the set-covering problem. Mathematics of Operations Research, 4(3):233โ235, 1979.
- [10] A.E.F. Clementi, P.ย Penna, and R.ย Silvestri. On the power assignment problem in radio networks. Electronic Colloquium on Computational Complexity (ECCC), (054), 2000.
- [11] R.L.ย Graham, M.ย Grรถtschel, and L.ย Lovรกsz, editors. Handbook of combinatorics. Vol. 1,ย 2. Elsevier Science B.V., Amsterdam, 1995.
- [12] C.ย Grรถpl, S.ย Hougardy, T.ย Nierhoff, and H.J.ย Prรถmel. Approximation algorithms for the Steiner tree problem in graphs. In D.-Z. Du and X.ย Cheng, editors, Steiner Trees in Industries, pages 235โ279. Kluwer Academic Publishers, Dordrecht, 2001.
- [13] Mohammadย Taghi Hajiaghayi, Nicole Immorlica, and Vahabย S. Mirrokni. Power optimization in fault-tolerant topology control algorithms for wireless multi-hop networks. In MOBICOM, pages 300โ312, 2003.
- [14] Mohammadย Taghi Hajiaghayi, Guy Kortsarz, Vahabย S. Mirrokni, and Zeev Nutov. Power optimization for connectivity problems. Math. Program., 110(1):195โ208, 2007.
- [15] L.ย M. Kirousis, E.ย Kranakis, D.ย Krizanc, and A.ย Pelc. Power consumption in packet radio networks. Theoretical Computer Science, 243:289โ305, 2000.
- [16] Guy Kortsarz, Vahabย S. Mirrokni, Zeev Nutov, and Elena Tsanko. Approximating minimum-power degree and connectivity problems. In LATIN, pages 423โ435, 2008.
- [17] Zeev Nutov and Ariel Yaroshevitch. Wireless network design via 3-decompositions. Inf. Process. Lett., 109(19):1136โ1140, 2009.
- [18] Ram Ramanathan and Regina Rosales-Hain. Topology control of multihop wireless networks using transmit power adjustment. In INFOCOM (2), pages 404โ413, 2000.
- [19] G.ย Robins and A.ย Zelikovsky. Improved Steiner tree approximation in graphs. In ACM-SIAM Symposium on Discrete Algorithms, pages 770โ779, 2000.
- [20] G.ย Robins and A.ย Zelikovsky. Tighter bounds for graph Steiner tree approximation. SIAM Journal of Discrete Mathematics, 19(1):122โ134, 2005.
- [21] A.ย Schrijver. Combinatorial Optimization. Springer, 2003.
- [22] Roger Wattenhofer, Liย Li, Paramvir Bahl, and Yi-Min Wang. Distributed topology control for wireless multihop ad-hoc networks. In IEEE INFOCOMโ01, 2001.
- [23] A.ย Zelikovsky. Better approximation bounds for the network and Euclidean Steiner tree problems. Technical Report CS-96-06, Department of Computer Science, University of Virginia, 1996.